/**
 * ==================================================================
 * CHANGE HISTORY for MQWhat.h
 * ------------------------------------------------------------------
 * Date       Change-id   Produced  User Name
 * yyyymmdd               Version.
 *                        rr.ss.uu
 * Reason
 * ------------------------------------------------------------------
 * 20090921   RML000      01.00.00  R. Lacroix
 * Birth.
 *
 *
 * ------------------------------------------------------------------
 */
#ifndef __MQWHATDEF
   #define __MQWHATDEF 1 /*Indicate that this file has been incl.*/

/*
 * Global defines.
 */
#define SUBKEY_MQ_VERSION_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion"

#define SUBKEY_MQ_COMPONENT_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion\\Components"

#define SUBKEY_MQ_QMGRS_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion\\Configuration\\QueueManager"

#define SUBKEY_MQ_QMGRS_LOG_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion\\Configuration\\QueueManager\\%s\\log"

#define SUBKEY_MQ_QMGR_STATUS_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion\\Status\\QueueManager\\%s\\QueueManagerStatus"

#define SUBKEY_MQ_QMGR_DEFAULT_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion\\Configuration\\DefaultQueueManager"

#define SUBKEY_MQ_MAINT_SETTING  \
"SOFTWARE\\IBM\\MQSeries\\CurrentVersion\\Maintenance Applied"

#define MQWHAT_OUTPUT_FILE    "mqwhat.temp.txt"

#define FILE_LINE_LENGTH      200
#define PIPE_BUFFER_SIZE      4096
#define TOTAL_LISTENER_PARMS  4
#define TOTAL_SERVICE_PARMS   2

#define SM_SERVERR2  98

/*
 * Structures
 */
typedef struct QMGR_S
{
   char        Name[MQ_Q_MGR_NAME_LENGTH+1];

} QMGR_T;

typedef struct OUTPUT_LINE_S
{
   char        Line[FILE_LINE_LENGTH+1];

} OUTPUT_LINE_T;


/*
 * Prototypes
 */
void GetMQVersion();
void GetMQComponentList();
void GetMQQMgrsList();
void GetMQQMgrStatus(char *, char *, int );
void GetMQDefaultQMgr(char *, int );
void GetMQMaintenanceList();
void GetMQIndividualQMgrInfo();
void GetMQListeners(char *);
void GetMQQMgrLog(char *);
void GetMQServices(char *);

void Setup_runmqsc(char *, char *, char *, OUTPUT_LINE_T * );
void Launch_runmqsc(char *);
void ReadFromPipe(char *, OUTPUT_LINE_T *);

void ExtractValue(char *, char *, char *);
void DumpKey(char *, HKEY, char *, char * );
void DumpKey_DWord(char *, HKEY, char * );
void CreateTabs(char *, char *, int, int );
void ConvertMQObjectName(char *, char *);

#endif  /* End of header file */
